
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 04/26/2013 06:01:12
-- Generated from EDMX file: D:\Microsoft Press\Entity Framework Development Step by Step\Chapter 16\ModelFirst (Inheritance)\TestModelFirst\Rewards2Model.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [Rewards4];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_CustomersPurchases]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Purchases] DROP CONSTRAINT [FK_CustomersPurchases];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Customers]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Customers];
GO
IF OBJECT_ID(N'[dbo].[Purchases]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Purchases];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Purchases'
CREATE TABLE [dbo].[Purchases] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [PurchaseDate] datetime  NOT NULL,
    [Amount] decimal(18,2)  NOT NULL,
    [CustomersId] int  NOT NULL,
    [PeopleId] int  NOT NULL
);
GO

-- Creating table 'People'
CREATE TABLE [dbo].[People] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'People_Customers'
CREATE TABLE [dbo].[People_Customers] (
    [CustomerType] int  NOT NULL,
    [Discount] decimal(18,0)  NULL,
    [Id] int  NOT NULL
);
GO

-- Creating table 'People_Employees'
CREATE TABLE [dbo].[People_Employees] (
    [EmployeeType] int  NOT NULL,
    [Id] int  NOT NULL
);
GO

-- Creating table 'People_Managers'
CREATE TABLE [dbo].[People_Managers] (
    [Discount] decimal(18,0)  NOT NULL,
    [Id] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [Id] in table 'Purchases'
ALTER TABLE [dbo].[Purchases]
ADD CONSTRAINT [PK_Purchases]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'People'
ALTER TABLE [dbo].[People]
ADD CONSTRAINT [PK_People]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'People_Customers'
ALTER TABLE [dbo].[People_Customers]
ADD CONSTRAINT [PK_People_Customers]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'People_Employees'
ALTER TABLE [dbo].[People_Employees]
ADD CONSTRAINT [PK_People_Employees]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'People_Managers'
ALTER TABLE [dbo].[People_Managers]
ADD CONSTRAINT [PK_People_Managers]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [PeopleId] in table 'Purchases'
ALTER TABLE [dbo].[Purchases]
ADD CONSTRAINT [FK_PeoplePurchases]
    FOREIGN KEY ([PeopleId])
    REFERENCES [dbo].[People]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_PeoplePurchases'
CREATE INDEX [IX_FK_PeoplePurchases]
ON [dbo].[Purchases]
    ([PeopleId]);
GO

-- Creating foreign key on [Id] in table 'People_Customers'
ALTER TABLE [dbo].[People_Customers]
ADD CONSTRAINT [FK_Customers_inherits_People]
    FOREIGN KEY ([Id])
    REFERENCES [dbo].[People]
        ([Id])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating foreign key on [Id] in table 'People_Employees'
ALTER TABLE [dbo].[People_Employees]
ADD CONSTRAINT [FK_Employees_inherits_People]
    FOREIGN KEY ([Id])
    REFERENCES [dbo].[People]
        ([Id])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating foreign key on [Id] in table 'People_Managers'
ALTER TABLE [dbo].[People_Managers]
ADD CONSTRAINT [FK_Managers_inherits_People]
    FOREIGN KEY ([Id])
    REFERENCES [dbo].[People]
        ([Id])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------